<?php
/*
   Copyright (C) 2002-2003 Index Data Aps, www.indexdata.dk

   This file is part of TKLITE.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 dated June, 1991.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   A copy of the GNU General Public License is also available at
   <URL:http://www.gnu.org/copyleft/gpl.html>.  You may also obtain
   it by writing to the Free Software Foundation, Inc., 59 Temple
   Place - Suite 330, Boston, MA 02111-1307, USA.

   $Id: dirbrowse.php,v 1.15 2004-07-30 12:00:02 marc Exp $
*/

require "config.php";
require "standards.php";
require "util/catutil.phpi";

header("Content-Type: text/html; charset=utf-8");

?>
<html>
<HEAD>
    <TITLE>Katalog browser</TITLE>
    <link rel="stylesheet" type="text/css" href="styles.css" />
    <?php cat_browse_init()?>
</HEAD>
<body>


<?php

if (!isset($cwd)) {
    echo "<b>Remember to pass info about directory</b>";
    die;
}
if (!($doc_root = check_path($cwd))) {
    exception("Udenfor dokumentomrdet");
    die;
}
$path = get_path(preg_replace("/^\//", "", normalize_path($cwd)));
foreach ($path as $dir) {
    $pathString .= "$dir/";
}
$pathString = preg_replace("/^\//", "", normalize_path($pathString));
$abs_cwd = $_SERVER['DOCUMENT_ROOT'] . "/$cwd";

echo insert_path($browse_script, "&form_name=$form_name&field_name=$field_name");

echo "<p>";
echo "&nbsp;&nbsp;&nbsp;<a href=\"#\" onclick='javascript: InsertTerm(\"/$pathString\",\"$form_name\",\"$field_name\",\"P\")' title=\"Overfr denne sti til editoren\">/</a><br>\n";
if ($dh = @opendir($abs_cwd)) {
    while ($entry = readdir($dh)) {
    	if (neglect_file($entry) or !is_dir("$abs_cwd/$entry")) {
    	    continue;
    	}
	$index_file = "$abs_cwd/$entry/index.tkl";
	if (file_exists($index_file)) {
	    $sub_title = get_title($index_file);
	} else {
	    $sub_title = "Uden titel";
	}
    	echo "<a href=\"$browse_script?", makeparms($context, array("cwd"=>"$cwd/$entry", "form_name"=>"$form_name", "field_name"=>"$field_name")), "\">+</a> <a href=\"#\" onclick='javascript: InsertTerm(\"/$pathString$entry/\",\"$form_name\",\"$field_name\",\"P\")' title=\"Overfr denne sti til editoren\">$entry - \"$sub_title\"</a><br>\n";
    }
    closedir($dh);
}

?>

</body>
</html>
