<?php
/*
   Copyright (C) 2002-2003 Index Data Aps, www.indexdata.dk

   This file is part of TKLITE.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 dated June, 1991.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   A copy of the GNU General Public License is also available at
   <URL:http://www.gnu.org/copyleft/gpl.html>.  You may also obtain
   it by writing to the Free Software Foundation, Inc., 59 Temple
   Place - Suite 330, Boston, MA 02111-1307, USA.

   $Id: z-probe.php,v 1.2 2003-09-09 13:56:02 adam Exp $
*/

header("Content-Type: text/html; charset=utf-8");

?>
<html>
  <head>
    <title>Z39.50 probing</title>
    <link rel="stylesheet" type="text/css" href="../admin/admin.css" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  </head>
  <body>
    <table>
<?php

$zurl = $_REQUEST['zurl'];
$options = array();

echo "<tr><td colspan=\"2\"><b>Probing $zurl ...</b></td></tr>\n";

$yaz = yaz_connect($zurl, $options);

yaz_search($yaz, 'rpn', '@attr 1=4 test');
yaz_wait(array(timeout => 15));

echo "<tr><td colspan=\"2\">&nbsp;</td></tr>\n";
echo "<tr><td><b>Target reported:</b></td><td>";


if (strlen($diag = yaz_error($yaz))) {
    echo "[", yaz_errno($yaz), "] ", $diag;
} else {
    echo "Ok";
}

echo "</td></tr>\n";

?>
      <tr>
        <td colspan="2">&nbsp;</td>
      </tr>
      <tr>
        <td colspan="2">
	  <form>
	    <input type="button" value="Close" onClick="window.close()">
	  </form>
	</td>
      </tr>
    </table>
  </body>
</html>
