<?php
/*
   Copyright (C) 2002-2003 Index Data Aps, www.indexdata.dk

   This file is part of TKLITE.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 dated June, 1991.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   A copy of the GNU General Public License is also available at
   <URL:http://www.gnu.org/copyleft/gpl.html>.  You may also obtain
   it by writing to the Free Software Foundation, Inc., 59 Temple
   Place - Suite 330, Boston, MA 02111-1307, USA.

   $Id: shell-util.php,v 1.4 2003-09-09 13:56:01 adam Exp $
*/
?><?php 

class XML_getschema {
    var $my_schema;
    var $document_root;

    function XML_getschema($xml) {
	$this->my_schema = '';
	$this->document_root = 1;
	$xp = xml_parser_create();
	xml_parser_set_option($xp, XML_OPTION_CASE_FOLDING, 0);
	xml_parser_set_option($xp, XML_OPTION_TARGET_ENCODING, "UTF-8");
	xml_set_element_handler($xp, array(&$this, "elem_begin"),
	    array(&$this, "elem_end"));
	xml_parse($xp, $xml);
	xml_parser_free($xp);
    }

    function elem_end($xp, $elem) {}

    function elem_begin($xp, $elem, $att) {
	if ($this->document_root) {
	    $this->my_schema = $elem;
	    $this->document_root = 0;
	}
    }

    function schema() {
	return $this->my_schema;
    }
}

?>
