<?php
/*
   Copyright (C) 2002-2003 Index Data Aps, www.indexdata.dk

   This file is part of TKLITE.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 dated June, 1991.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   A copy of the GNU General Public License is also available at
   <URL:http://www.gnu.org/copyleft/gpl.html>.  You may also obtain
   it by writing to the Free Software Foundation, Inc., 59 Temple
   Place - Suite 330, Boston, MA 02111-1307, USA.

   $Id: browse.php,v 1.8 2003-09-09 13:56:01 adam Exp $
*/
?><html>
<head>

<?php

require('config.php');
require('util/util.php');
require 'standards.php';
require 'util/catutil.phpi';
cat_browse_init();
$action = "scan";
$debug = 0;
$queryprint = 0;
?>
    <Title>Browse - <?php echo $dbname?></Title>
    <link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body onLoad="window.focus();document.Browse.term1.focus();">
<form method="GET" action="<?php echo $PHP_SELF?>" name="Browse">
    <input type="text" name="term1" size="30" value="<?php echo $term1?>">
    <input type="hidden" name="form_name" value="<?php echo $form_name?>">
    <input type="hidden" name="field_name" value="<?php echo $field_name?>">
    <input type="hidden" name="target" value="<?php echo $target?>">
    <input type="hidden" name="field1" value="<?php echo $field1?>">
    <br>
    <input TYPE="image" NAME="" VALUE="Search" src="grafik/emnesoeg_knap.gif" border="0"><BR>
</form>
<?php
$connections = array();
$errormsg = '';
$selected_targets = array($target);
reset($selected_targets);
while (list($key, $group) = each($selected_targets)) {		// Extract unique z-urls
    if ($target_group[$group]['primary-search'] != "") {
    	while (list($key2, $target) = each($target_group[$group]['primary-search'])) {
    		$connections[$target]['zurl'] = $targets[$target]['zurl'];
    	}
    }
}
$connections[$target]['zurl'] = $target;
while (list($target) = each($connections)) {			// And here we go, lets perform the search
	$info = $targets[$target];
	$dbname = $info['name'][$lang];
	if (!$start) {
		$start = 1;
	}
	$id = yaz_connect($connections[$target]['zurl']);
	$connections[$target]['conn'] = $id;
//	yaz_syntax($id, $info['syntax']);
    yaz_syntax($id, "grs1");
	if ($info['elementset']) {
		yaz_element($id, $info['elementset']);
	} else {
		yaz_element($id, "f");
	}
	if (empty($focus) || $focus == $target) {
		yaz_range($id, $start, $records_page);
	} else {
		yaz_range($id, 1, 0);
	}
	if ($info['ccl_conf']) {
		$cc = $info['ccl_conf'];
	} else {
		$cc = $ccl_conf;
	}
//	yaz_ccl_conf($id, $cc);
    if ($term1 != "") {
        $query = "$field1 $term1";
    	$query = stripslashes($query);
    }
	if (0) {
	if (empty($query)) {
		foreach ($GLOBALS as $name => $value) {
			if (ereg("(cclterm)([1-9])+", $name, $regs)) {
				if (!empty($value)) {
					$value = check_term($value);
//					echo "$name, $regs[2], $value " .$GLOBALS["cclfield$regs[2]"];
					if (empty($GLOBALS["cclfield$regs[2]"])) {
						$subQuery = "($value)";
					} else {
						$subQuery = $GLOBALS["cclfield$regs[2]"] ."=($value)";
					}
					if (empty($query)) {
						$query = "($subQuery)";
					} else {
						$query = "($query and ($subQuery))";
					}
				}
			}
		}
	}
    }
    if ($queryprint) {
        echo "Query er her $query<BR>";
    }
	if ($debug) {
		echo "DEBUG (parsed CCL): $ccl_query<BR>";
	}
	if (yaz_ccl_parse($id, $query, &$cclres)) {
//		$mquery = stripslashes($cclres['rpn']);
        $mquery = $query;
		if ($queryprint) {
			print "RPN er her: $mquery<BR>";
		}
		if ($info['search_prefix'])
			$mquery = $info['search_prefix'] . " $mquery";
		if ($info['ccl_attset'])
			$mquery = "@attrset " . $info['ccl_attset'] . ' ' . $mquery;
		if ($action == 'scan') {
			yaz_scan($id, 'rpn', $mquery, array('number' => $scannumber));
		} else {
			yaz_search($id, 'rpn', $mquery);
		}
	} else {
		$errormsg .= "<TR><TD><DIV CLASS=\"ressp\">$dbname: Foresprgslen indeholder fejl, prv igen</DIV</TD></TR>\n";
	}
}
?>
<?php
yaz_wait();
$show = 0;
reset($connections);
while (list($target) = each($connections)) {
	$info = $targets[$target];
	$id = $connections[$target]['conn'];
	if (is_array($info['name'])) {
		$dbname = $info['name'][$lang];
	} else {
		$dbname = $info['name'];
	}
	if ($no = yaz_errno($id)) {
		if ($no == 113 || $no == 114) {
			$errormsg .= "<TR><TD><DIV CLASS=\"ressp\">$dbname: Understtter ikke anvendt sgefelt</DIV></TD></TR>\n";
		} else {
			$errormsg .= "<TR><TD><DIV CLASS=\"ressp\">$dbname: Rapporterer anden fejlmeddelelse: ".yaz_error($id)." ($no)</DIV</TD></TR>\n";
		}
	} else {
		//echo "<P>\n";
		if ($action == 'scan') {
			$show = 1;
			if (empty($focus)) {
				$focus = $target;
			}
		} else {
			$hits = yaz_hits($id);
			$connections[$target]['hits'] = $hits;
			if ($hits) {
				$show = 1;
				if (empty($focus)) {
					$focus = $target;
				}
			}
		}
	}
}

?>

    <TD rowspan="3" valign="top" align="right" width="160" height="23">
      <?php //echo parmList(array("records_page"))?>

    </TD>
    <TD rowspan="3"  valign="top" width="399">&nbsp;</TD>
  </TR>
  <TR>
    <TD bgcolor="#ffffff" align="right">
        <TABLE border="0" bgcolor="#ffffff" cellpadding="0" cellspacing="0" width="100%">
            <TR valign="top">
                <td style="line-height: 11px;" class="dotted">&nbsp;</td>
            </TR>

<?php
foreach ($connections as $target => $info) {
	$hits = $info['hits'];
	if ($hits || $action == 'scan') {
		if (!yaz_errno($info['conn'])) {
			$dbname = $targets[$target]['name'][$lang];
			if ($action != 'scan') {
				$msg .= " ($hits)";
			}
			echo "<TR valign=\"top\"><TD align=\"left\" valign=\"middle\" width=225>";
			if ($focus == $target) {
				echo "<DIV CLASS=ressp>$msg</DIV>";
			} else {
				echo "<DIV CLASS=ressp>", HTML_anchorParms($PHP_SELF, $msg, $context, array('focus' => $target, 'start' => 1), 'output'), "</DIV>";
			}
			echo "</TD></TR>";
		}
	}
}
?>
            <TR><TD>&nbsp;</TD></TR>
        </TABLE>
    </TD>
  </TR>

  <TR><TD bgcolor="#ffffff" align="right" height="100%" valign="top">
<?php
if (!$show) {
	echo "Ingen fund\n";
} else {
	$info = $targets[$focus];
	if ($action == 'scan') {
		show_browse_results($connections[$focus]['conn'], $info, "");
	} else {
		portal_show_records($connections[$focus]['conn'], $info, "");
	}
}

if (!empty($errormsg)) {
	echo "<TABLE border=\"0\" bgcolor=\"#ffffff\" cellpadding=\"0\" cellspacing=\"0\" width=\"420\">";
	echo "<TR><TD>&nbsp;</TD></TR>$errormsg<TR><TD>&nbsp;</TD></TR>";
	echo "</TABLE>\n";
}

?>
</body>
</html>
