<?php
/*
   Copyright (C) 2002-2003 Index Data Aps, www.indexdata.dk

   This file is part of TKLITE.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 dated June, 1991.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   A copy of the GNU General Public License is also available at
   <URL:http://www.gnu.org/copyleft/gpl.html>.  You may also obtain
   it by writing to the Free Software Foundation, Inc., 59 Temple
   Place - Suite 330, Boston, MA 02111-1307, USA.

   $Id: handler.php,v 1.7 2003-09-09 13:56:02 adam Exp $
*/


function scheme_tkl_file($scheme, $path) {
    global $debug, $root, $admin;
    $opath = $path;

    $path = preg_replace("/^./", "", $path); // Remove leading /
    if (preg_match("/^\//", $path)) {
	$absolute = $_SERVER['DOCUMENT_ROOT'];
	$path = $_SERVER['DOCUMENT_ROOT'] . $root . $path;
    }
    if ($debug) {
	print "<hr>Loading file, scheme is $scheme, path is $opath => $path<p>";
    }
    if (!$admin || preg_match("/\.tkl$/", $path)) {

      if(is_readable($path)) {
	$doc = join('', file($path));
	$t = new XML_process_stylesheet($doc);
	$doc = $t->buf();
      } else {
	$doc = "<error>File '$path' not found or no read permission</error>";
      }

    } else {
	$doc = "<error>Not a tkl file</error>";
    }
    return $doc;
}

?>
