<?php
/*
   Copyright (C) 2002-2003 Index Data Aps, www.indexdata.dk

   This file is part of TKLITE.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; version 2 dated June, 1991.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   A copy of the GNU General Public License is also available at
   <URL:http://www.gnu.org/copyleft/gpl.html>.  You may also obtain
   it by writing to the Free Software Foundation, Inc., 59 Temple
   Place - Suite 330, Boston, MA 02111-1307, USA.

   $Id: single_url.php,v 1.7 2004-07-28 14:35:25 marc Exp $
*/
?>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>URL checker</title>
<link rel="stylesheet" type="text/css" href="/tkl/admin/admin.css">
</head>
<body>

<?php

require_once("../config.php");
require_once("../standards.php");
require_once("../util/checkurl.php");

$flags["debug"] = 0;
$flags["timeout"] = 10;

$res = check_url($url, $flags);

echo "Checking URL<br/>";
echo "&nbsp;" . $url . "<br/>";
if ($res["error"]) {
    echo "URL Error: " . $res["error"] . "<br/>";
    if ($res["error"] == "HTTP") {
        echo "HTTP code: " . $res["HTTP-code"] . "<br/>";
    }
} else {
    echo "URL OK<br/>";
    if (strlen($res["permanent-url"]) && $url != $res["permanent-url"]) {
        echo "Permanent URL is:<br/>";
	echo "&nbsp;" . $res["permanent-url"];
    }
}
echo "<p/>\n";
if (($url_exists = dublet_check($url, "/link/identifier")) == 2) {
    echo "URL'en findes i databasen.";
} elseif ($url_exists == 1) {
    echo "URL'en findes endnu ikke i databasen.";
} else {
    echo "URL dubletcheck ikke mulig.";
}
?>
    </body>
</html>
